#ifndef COMMON_H
#define COMMON_H


#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <iostream>
using namespace std;

#define SAFE_FREE(x) do { if (x) { free(x); x = NULL; }}while(0)
#define FATAL(x) do {cerr << "Fatal error at " << __FILE__ << ":" << __FUNCTION__ <<":" << __LINE__ <<": "<< x << "; exit forced.\n"; exit(1);}while(0)

#define MAX(x, y) ((x)>(y) ? (x) : (y))
#define MIN(x, y) ((x)<(y) ? (x) : (y))
#define ABS(x) ( (x) >= 0 ? (x) : (-(x)))

#define ROUND2DECIMALS(x) (((double)((int)(x*100)))/100.0)

#define WITHIN(x,a,b) (a <= x && x <= b)

#define NOTNANINF(x) ( !(std::isnan(x)) && !(std::isinf(x)))
#define POSITIVE0(x) ( (x) == -0 ? 0 : (x))

#define INCSTEP(min,max,n) ((max-min)/(double)n)

#define uint unsigned int

#define SQRT3 1.73205081

#define PNORMALIZE(x) (x < 0 ? 0 : (x > 1 ? 1 : x))

#define POW2(x) ((x)*(x))

//#define LOG(x) do { cout << x; }while(0)

#define LOG(x) do { }while(0)


#endif // COMMON_H
