#ifndef EVALUATION_H
#define EVALUATION_H

#include "graph.h"
#include "elapsedtime.h"

class Evaluation
{
public:
    Evaluation(Graph *_graph);

    void setupTrainingSet(double P);
    void initTrainingSet();
    double test();
    static double testAccuracy(Graph *graph, int iterationCount);
    static double testAccuracy(Graph *graph);
    void printConfusionMatrix();
    void printAssignedLabels();

    ElapsedTime time;


    Graph *graph;

};

#endif // EVALUATION_H
